freeslot(
"SPR_SHSP",
"S_CHAOSSPEAR",
"S_SPEARCIRCLE",
"SPR_SHSC",
"MT_CHAOSSPEAROVERLAY",
"MT_CHAOSSPEARTRAIL",
"MT_CHAOSBLAST",
"MT_CHAOSSNAP",
"MT_SHADOW_CHAOSCONTROL",
"S_CHAOSSNAP1",
"S_CHAOSSNAP2",
"SPR_CHBL",
"SFX_BKCHAS",
"SFX_BKSPER",
"SFX_BKBLAS",
"SFX_BKSPSH",
"SFX_CSNAP",
"SFX_CCONT",
"SFX_CBST",
"SPR_SHCE",
"SPR_SCHC",
"SPR_BDRK",
"S_CHAOSBLAST",
"S_SHADOW_CHAOSEMERALD",
"S_SHADOW_CHAOSCONTROL_ORB",
"S_SHADOW_CHAOSCONTROL_BEAM",
"S_DARKRIDER_BORKED"
)
mobjinfo[MT_CHAOSSPEARTRAIL] = {
	doomednum = -1,
	spawnstate = S_CHAOSSPEAR,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}
mobjinfo[MT_CHAOSSPEAROVERLAY] = {
	doomednum = -1,
	spawnstate = S_CHAOSSPEAR,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}
mobjinfo[MT_CHAOSBLAST] = {
	doomednum = -1,
	spawnstate = S_CHAOSBLAST,
	dispoffset = 4,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}
mobjinfo[MT_SHADOW_CHAOSCONTROL] = {
	doomednum = -1,
	spawnstate = S_SHADOW_CHAOSEMERALD,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}
states[S_CHAOSSPEAR] = {
	sprite = SPR_SHSP,
	frame = FF_ANIMATE|FF_FULLBRIGHT,
	tics = 2,
	var1 = -1,
	nextstate = S_CHAOSSPEAR,
}
states[S_DARKRIDER_BORKED] = {
	sprite = SPR_BDRK,
	frame = A,
	tics = 2,
	var1 = -1,
	nextstate = S_DARKRIDER_BORKED,
}
states[S_SHADOW_CHAOSEMERALD] = {
	sprite = SPR_SHCE,
	frame = A|FF_FULLBRIGHT,
	tics = 2,
	var1 = -1,
	nextstate = S_SHADOW_CHAOSEMERALD,
}
states[S_SHADOW_CHAOSCONTROL_ORB] = {
	sprite = SPR_SCHC,
	frame = FF_FULLBRIGHT|A,
	tics = -1,
	nextstate = S_SHADOW_CHAOSCONTROL_ORB,
}
states[S_SHADOW_CHAOSCONTROL_BEAM] = {
	sprite = SPR_SCHC,
	frame = FF_FULLBRIGHT|B,
	tics = -1,
	nextstate = S_SHADOW_CHAOSCONTROL_BEAM,
}
local v1 = 18
states[S_CHAOSBLAST] = {
	sprite = SPR_CHBL,
	frame = FF_ANIMATE|FF_FULLBRIGHT,
	tics = v1*2,
	var1 = v1,
	var2 = 2,
	nextstate = S_NULL,
}
states[S_SPEARCIRCLE] = {
	sprite = SPR_SHSC,
	frame = FF_FULLBRIGHT,
	tics = 2,
	var1 = -1,
	nextstate = S_SPEARCIRCLE,
}
local shadowpresent = 0
addHook("MapLoad", do
	shadowpresent = 0
end)
//shadow android singleplayer reskin
addHook("PlayerThink", function(p)
	if not (p and p.mo and p.mo.valid and p.mo.health and (p.mo.skin == "shadow" or p.mo.skin == "bikeshadow")) return end
	--p.mo.blendmode = AST_ADD
		--print(leveltime)
	if not (p.bot)
		shadowpresent = 3
		--print("shadowpresent set")
	else
		if p.mo.skin == "shadow"
			shadowpresent = max($, 1)
		end
		if p.mo.skin == "bikeshadow"
			shadowpresent = max($, 2)
		end
	end
	if p.bot
		if p.mo.skin == "shadow" and shadowpresent > 1 or p.mo.skin == "bikeshadow" and shadowpresent > 2
			--p.mo.color = SKINCOLOR_COPPER
			p.skincolor = SKINCOLOR_COPPER
			--p.mo.momz = 2*FRACUNIT
		end
	end
end)
local colors = {}
colors[MT_JAWZ] = SKINCOLOR_RED
colors[MT_JAWZ_SHIELD] = SKINCOLOR_RED
colors[MT_ORBINAUT] = SKINCOLOR_ROYAL
colors[MT_ORBINAUT_SHIELD] = SKINCOLOR_ROYAL
//chaos spear trail
addHook("MobjThinker", function(mo)
	if not  (mo and mo.valid and mo.health) return end
		mo.scale = max(0, $-mo.basescale/10)
		if mo.fuse <= 8
			mo.state = S_SPEARCIRCLE
		end
end, MT_CHAOSSPEARTRAIL)

//chaos spear/lance reskin stuff
local spearthinker = function(mo) 
	if mo and mo.valid and mo.target and mo.target.skin == "bikeshadow"
		if not mo.init
			if mo.type == MT_ORBINAUT or mo.type == MT_JAWZ
				mo.target.SaySpearRightNow = true
			elseif mo.type == MT_ORBINAUT_SHIELD or mo.type == MT_JAWZ_SHIELD
				mo.target.SayChaosRightNow2 = true
			end
			mo.init = true
		end
		mo.lastx = $ or mo.x
		mo.lasty = $ or mo.y
		mo.lastz = $ or mo.z
		mo.state = S_INVISIBLE
		--mo.renderflags = $|RF_DONTDRAW
		/*if not (mo.spearoverlay and mo.spearoverlay.valid)
			local over = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_CHAOSSPEAROVERLAY)
			over.color = colors[mo.type]
			over.target = mo
			over.renderflags = $|RF_ADD
			mo.spearoverlay = over
			over.spriteyoffset = FRACUNIT*45
		end*/
		local dist = R_PointToDist2(mo.lastx, mo.lasty, mo.x, mo.y)
		local angle = R_PointToAngle2(mo.lastx, mo.lasty, mo.x, mo.y)
		//spawn 10 speartrails
		for i = 1, 10 do
			local trail = P_SpawnMobj(mo.lastx+P_ReturnThrustX(mo, angle, dist/i*2), mo.lasty+P_ReturnThrustY(mo, angle, dist/i*2), mo.z+((mo.z-mo.lastz)/i), MT_CHAOSSPEARTRAIL)
			--trail.state = S_SPEARCIRCLE
			trail.basescale = mo.scale
			trail.fuse = 10
			trail.destscale = 0
			trail.angle = angle
			trail.spriteyoffset = FRACUNIT*45
			--trail.scalespeed = mo.scale/4
			trail.color = colors[mo.type]
			--if mo.color != SKINCOLOR_YELLOW
				--mo.colorized = true
			--end
			trail.renderflags = $| RF_ADD
			trail.scale = mo.scale-(mo.scale/100)*i
			
		end
		mo.lastx = mo.x
		mo.lasty = mo.y
		mo.lastz = mo.z
	end
end
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.target and mo.target.valid
			P_MoveOrigin(mo, mo.target.x+(mo.target.momx/4), mo.target.y+(mo.target.momy/7), mo.target.z+(mo.target.momz/7))
			mo.angle = mo.target.angle
			mo.scale = mo.target.scale
		else
			P_RemoveMobj(mo)
		end
	end
end, MT_CHAOSSPEAROVERLAY)
local thokstates = {} --i dont think theres a better way to do this /:
thokstates[S_KSPARK1] = true
thokstates[S_KSPARK2] = true
thokstates[S_KSPARK3] = true
thokstates[S_KSPARK4] = true
thokstates[S_KSPARK5] = true
thokstates[S_KSPARK6] = true
thokstates[S_KSPARK7] = true
thokstates[S_KSPARK8] = true
thokstates[S_KSPARK9] = true
thokstates[S_KSPARK10] = true
thokstates[S_KSPARK11] = true
thokstates[S_KSPARK12] = true
thokstates[S_KSPARK13] = true

thokstates[S_LZIO11] = true
thokstates[S_LZIO12] = true
thokstates[S_LZIO13] = true
thokstates[S_LZIO14] = true
thokstates[S_LZIO15] = true
thokstates[S_LZIO16] = true
thokstates[S_LZIO17] = true
thokstates[S_LZIO18] = true
thokstates[S_LZIO19] = true

thokstates[S_LZIO21] = true
thokstates[S_LZIO22] = true
thokstates[S_LZIO23] = true
thokstates[S_LZIO24] = true
thokstates[S_LZIO25] = true
thokstates[S_LZIO26] = true
thokstates[S_LZIO27] = true
thokstates[S_LZIO28] = true
thokstates[S_LZIO29] = true

thokstates[S_KLIT1] = true
thokstates[S_KLIT2] = true
thokstates[S_KLIT3] = true
thokstates[S_KLIT4] = true
thokstates[S_KLIT5] = true
thokstates[S_KLIT6] = true
thokstates[S_KLIT7] = true
thokstates[S_KLIT8] = true
thokstates[S_KLIT9] = true
thokstates[S_KLIT10] = true
thokstates[S_KLIT11] = true
thokstates[S_KLIT12] = true
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.target and mo.target.skin == "bikeshadow"
		if thokstates[mo.state]
			mo.color = SKINCOLOR_RED
			mo.colorized = true
			if not (mo.inited)
				mo.target.ChaosBlastInit = true
			end
			mo.inited = true
			--P_RemoveMobj(mo)
		end
	end
end, MT_THOK)
addHook("MobjThinker", spearthinker, MT_ORBINAUT)
addHook("MobjThinker", spearthinker, MT_ORBINAUT_SHIELD)
addHook("MobjThinker", spearthinker, MT_JAWZ)
addHook("MobjThinker", spearthinker, MT_JAWZ_SHIELD)

local animations = {
{SPR_PWCL, respawnon = F, frames = 9, tpf = 2, single = true, layer = -1, rf = RF_FULLBRIGHT|RF_TRANS20},
{SPR_BOST, single = true, frames = 7, tpf = 3, colorized = true, layer = 2, rf = RF_FULLBRIGHT},
{SPR_GBDY, frames = 4, tpf = 3, layer = 1, rf = RF_MODULATE|RF_FULLBRIGHT|RF_TRANS30},
{SPR_TRNQ, single = true, growby = 5, frames = 7, tpf = 1, respawnon = 7, layer = -2, rf = RF_MODULATE|RF_FULLBRIGHT|RF_TRANS50},
{SPR_DBOS, cardinal = true, frames = 4, tpf = 1, layer = 0, rf = RF_FULLBRIGHT, onground = true}//,
//{SPR_LSSJ, growby = 5, frames = 0, tpf = 20, layer = 10, colorized = true, rf = RF_ADD|RF_FULLBRIGHT|RF_TRANS50}
//{SPR_DIEL, frames = 1, offset = J, spawnevery = 2, special = true, dontcolor = true}
}
local function adjustSPRITETrans(num)
    local theShift = min(10, num)
    if theShift >= 10
        return false
    end
    return (theShift<<RF_TRANSSHIFT)
end
addHook("ThinkFrame", function() --because hook order
	for p in players.iterate
		if not (p and p.mo and p.mo.valid and p.mo.skin == "bikeshadow") continue end
		/*if p.mo.state == S_KART_DEAD
			if p.mo.savedZ == nil
				p.mo.savedZ = p.mo.z + 45 * p.mo.scale
			end
			p.mo.z = p.mo.savedZ
			p.mo.momz = 0
			p.mo.momx = 0
			p.mo.momy = 0
		else
			p.mo.savedZ = nil
		end*/
		if p.mo.ShadowRNGSeed == nil
			p.mo.ShadowRNGSeed = LRNG.New(32, 599, 140)
		end
		local SRNG = p.mo.ShadowRNGSeed
		--print(LRNG.NextRange(p.mo.ShadowRNGSeed, -15, 15))
		if p.itemtype == KITEM_LIGHTNINGSHIELD or p.invincibilitytimer > 0
			--if splitscreen --splitscreen sucks and is dumb and bad
				--p.aizdrifttilt = 0
			--end
			if (leveltime % 25 == 0) or (leveltime % 15 == 0)
				//P_SpawnParaloop(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), p.mo.radius*2, 16, MT_SIGNSPARKLE, FixedAngle(P_RandomRange(0, 360)*FU), S_NULL, true)
				local shitSpark = P_SpawnMobjFromMobj(
					p.mo,
					(LRNG.NextRange(p.mo.ShadowRNGSeed, -256, 256) * p.mo.scale),
					(LRNG.NextRange(p.mo.ShadowRNGSeed, -256, 256) * p.mo.scale),
					(LRNG.NextRange(p.mo.ShadowRNGSeed, 32, 256) * p.mo.scale)*P_MobjFlip(p.mo),
					MT_SIGNSPARKLE)
				shitSpark.colorized = true
				shitSpark.color = SKINCOLOR_TAFFY
				shitSpark.renderflags = RF_TRANS10|RF_NOCOLORMAPS|RF_FULLBRIGHT|RF_ADD
				shitSpark.fuse = 5
				shitSpark.flags = $ | MF_NOCLIPTHING
			end
			for i = 1, 2 do
				local thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
				thok.renderflags = $|RF_FULLBRIGHT|RF_ADD
				local spread = 128
				if P_MobjFlip(p.mo) == 1
					P_SetOrigin(thok, p.mo.x+LRNG.NextRange(p.mo.ShadowRNGSeed, -spread, spread)*p.mo.scale, p.mo.y+LRNG.NextRange(p.mo.ShadowRNGSeed, -spread, spread)*p.mo.scale, p.mo.z+LRNG.NextRange(p.mo.ShadowRNGSeed, -25, spread+spread/4)*p.mo.scale)
				else
					P_SetOrigin(thok, p.mo.x+LRNG.NextRange(p.mo.ShadowRNGSeed, -spread, spread)*p.mo.scale, p.mo.y+LRNG.NextRange(p.mo.ShadowRNGSeed, -spread, spread)*p.mo.scale, p.mo.z+(-LRNG.NextRange(p.mo.ShadowRNGSeed, -25, spread+spread/4))*p.mo.scale)
				end
				if p.invincibilitytimer == 0
					thok.color = SKINCOLOR_RED
				else
					thok.color = SKINCOLOR_SAPPHIRE
				end
				thok.spritexscale = FRACUNIT/7*LRNG.NextRange(p.mo.ShadowRNGSeed, 1, 4)
				thok.spriteyscale = thok.spritexscale
			end
			if (not p.mo.BlastEffects) or (p.mo.BlastEffects and not p.mo.BlastEffects[0].valid)
				p.mo.BlastEffects = {}
				p.mo.funnyThing = {}
				for i = 0, 4 do
					p.mo.BlastEffects[i] = P_SpawnMobjFromMobj(p.mo, 0,0,0, MT_THOK)
					if i < 2
						p.mo.BlastEffects[i].spritexoffset = ((i*2) - 1) * 3 * FU
					else
						p.mo.BlastEffects[i].spriteyoffset = (((i-2)*2) - 1) * 3 * FU
					end
					p.mo.BlastEffects[i].colorized = true
					if p.invincibilitytimer == 0
						p.mo.BlastEffects[i].color = SKINCOLOR_RED
					else
						p.mo.BlastEffects[i].color = SKINCOLOR_SAPPHIRE
					end
					p.mo.BlastEffects[i].renderflags = RF_TRANS10|RF_NOCOLORMAPS|RF_FULLBRIGHT|RF_ADD
					p.mo.BlastEffects[i].dispoffset = -1
					p.mo.BlastEffects[i].sprite = SPR_PLAY
					p.mo.BlastEffects[i].skin = "bikeshadow"
					p.mo.BlastEffects[i].angle = p.drawangle
					if i == 4
						p.mo.BlastEffects[i].spritexoffset = FU
						p.mo.BlastEffects[i].spriteyoffset = FU
						p.mo.BlastEffects[i].dispoffset = 2
						p.mo.BlastEffects[i].renderflags = $&~RF_ADD
					end
				end
				p.mo.BlastEffectGhost = true
			else
				//tilting stuff for splitscreen, has some small issues when viewed from odd angles
				local tilt = p.aizdrifttilt
				local dir = p.aizdriftstraft or p.aizdriftstrat or 0 -- LOL there is a typo in the source code
				local facing = p.mo.angle
				local tiltRoll = FixedMul(tilt, cos(facing) + cos(facing - dir*ANGLE_90))
				local tiltPitch = FixedMul(tilt, -sin(facing) - sin(facing - dir*ANGLE_90))

				//tilting stuff for non-splitscreen, 100% accurate (provided water is not involved)
				local viewangle = R_PointToAngle(p.mo.x, p.mo.y)
				local viewdelta = (viewangle - p.mo.angle)
				local rolladd = FixedMul(p.aizdrifttilt, sin(abs(viewdelta))) + FixedMul(p.aizdrifttilt, cos(viewdelta))
				for i = 0, 4 do
					if p.mo.BlastEffects[i] and p.mo.BlastEffects[i].valid
						p.mo.BlastEffects[i].tics = 3
						if P_MobjFlip(p.mo) == 1
							P_MoveOrigin(p.mo.BlastEffects[i], p.mo.x, p.mo.y, p.mo.z)
						else
							P_MoveOrigin(p.mo.BlastEffects[i], p.mo.x, p.mo.y, p.mo.z-p.mo.height/3)
						end
						
						p.mo.BlastEffects[i].flags2 = p.mo.flags2
						p.mo.BlastEffects[i].eflags = p.mo.eflags
						p.mo.BlastEffects[i].scale = p.mo.scale
						p.mo.BlastEffects[i].state = p.mo.state
						p.mo.BlastEffects[i].frame = p.mo.frame
						p.mo.BlastEffects[i].angle = p.drawangle
						if splitscreen
							p.mo.BlastEffects[i].pitch = p.mo.pitch+tiltPitch
							p.mo.BlastEffects[i].roll = p.mo.roll+tiltRoll
							p.mo.BlastEffects[i].rollangle = p.mo.rollangle
						else
							p.mo.BlastEffects[i].pitch = p.mo.pitch
							p.mo.BlastEffects[i].roll = p.mo.roll
							p.mo.BlastEffects[i].rollangle = p.mo.rollangle+rolladd
						end
						p.mo.BlastEffects[i].spritexscale = p.mo.spritexscale
						p.mo.BlastEffects[i].spriteyscale = p.mo.spriteyscale
						p.mo.BlastEffects[i].fuse = 2
						p.mo.BlastEffects[i].renderflags = ($ & ~ RF_DONTDRAW) | (p.mo.renderflags&RF_DONTDRAW)
						if i == 4
							p.mo.BlastEffects[i].renderflags = $&~RF_TRANSMASK
							if p.invincibilitytimer == 0
								p.mo.BlastEffects[i].renderflags = $|adjustSPRITETrans(abs(sin(FixedAngle(leveltime*(FU*360/140))))*10/FU)
							else
								p.mo.BlastEffects[i].renderflags = $|adjustSPRITETrans(abs(sin(FixedAngle(leveltime*2*(FU*360/140))))*10/FU)|RF_ADD
							end
						end
					end
				end
			end
		else
			p.mo.BlastEffectGhost = false
		end
		//chaos blast visual effects
		if p.mo.ChaosBlastInit
			p.mo.ChaosOffset = leveltime
			
			/*local circle = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_CHAOSBLAST)
			circle.target = p.mo
			circle.scale = p.mo.scale+p.mo.scale/2
			circle.renderflags = $|RF_ADD
			--circle.color = SKINCOLOR_CRIMSON
			--circle.destscale = 20*FRACUNIT*/
			S_StartSound(p.mo, sfx_bkblas)
			S_StopSoundByID(p.mo, sfx_BKSHA1)
			S_StopSoundByID(p.mo, sfx_BKSHA2)
			p.mo.ChaosBlastInit = false
		end
		if p.mo.ChaosOffset 
		local time = leveltime - p.mo.ChaosOffset
		
		if time == 0
			for i = 1, #animations
				local set = animations[i]
				
				if set.cardinal
					for j = 1, 4
						table.insert(p.mo.funnyThing, P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK))
						local mobj = p.mo.funnyThing[#p.mo.funnyThing]
			
						mobj.state = S_INVISIBLE
						mobj.sprite = set[1]
						mobj.color = SKINCOLOR_TAFFY
						mobj.colorized = set.colorized or $
						mobj.destscale = $ * (set.growby or 1)
						mobj.leid = i
						mobj.dispoffset = set.layer
						mobj.angle = $ + (ANGLE_90 * (j-1))
						mobj.renderflags = set.rf or $
					end
				else
					table.insert(p.mo.funnyThing, P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK))
					local mobj = p.mo.funnyThing[#p.mo.funnyThing]
					
					mobj.state = S_INVISIBLE
					mobj.sprite = set[1]
					mobj.color = SKINCOLOR_TAFFY
					mobj.colorized = set.colorized or $
					mobj.destscale = $ * (set.growby or 1)
					mobj.leid = i
					mobj.dispoffset = set.layer
					mobj.renderflags = set.rf or $
				end
			end
		end
		
		for i = 1, #p.mo.funnyThing
			local mobj = p.mo.funnyThing[i]
			if mobj and mobj.valid 
				local set = animations[mobj.leid]
				P_MoveOrigin(mobj, p.mo.x, p.mo.y, p.mo.z + (set.onground and 1 or (p.mo.height / 2)))
				mobj.fuse = 2
				if time % (set.tpf or 1) == 0 
					mobj.frame = $ + 1
					if (mobj.frame&FF_FRAMEMASK) > set.frames
						mobj.frame = A
					end
					if set.single and mobj.frame == A 
						mobj.fuse = 1
						P_SpawnGhostMobj(mobj)
					end
					if set.respawnon and set.respawnon == mobj.frame
						table.insert(p.mo.funnyThing, P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK))
						local dmobj = p.mo.funnyThing[#p.mo.funnyThing]
						dmobj.state = S_INVISIBLE
						dmobj.sprite = set[1]
						dmobj.color = SKINCOLOR_TAFFY
						dmobj.colorized = set.colorized or $
						dmobj.leid = mobj.leid
						dmobj.dispoffset = set.layer
						dmobj.renderflags = set.rf or $
						dmobj.destscale = $ * (set.growby or 1)
					end
				end
			end
		end
		
		if time >= 40
			p.mo.chaosOffset = 0
			for i = 1, #p.mo.funnyThing
				local mobj = p.mo.funnyThing[i]
				
				if mobj and mobj.valid 
					local set = animations[mobj.leid]
					mobj.fuse = 1
					P_SpawnGhostMobj(mobj)
				end
			end
		end
	end
		
	end
end)
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.target and mo.target.valid and mo.target.skin == "bikeshadow"
		mo.renderflags = $|RF_DONTDRAW
	end
end, MT_LIGHTNINGSHIELD)



//darkrider shadow general script
addHook("PlayerThink", function(p)
	if not (p and p.mo and p.mo.valid and p.mo.skin == "bikeshadow") return end
	//chaos (blast) voice line
	if p.itemtype == KITEM_LIGHTNINGSHIELD
		if not (p.SayChaosRightNow)
			S_StartSound(p.mo, sfx_bkchas)
			p.SayChaosRightNow = true
		end
	else
		p.SayChaosRightNow = false
	end
	//spear voice line
	if p.mo.SaySpearRightNow
		if not S_SoundPlaying(p.mo, sfx_bksper)
			S_StartSound(p.mo, sfx_bksper)
		end
		S_StartSound(p.mo, sfx_bkspsh)
		S_StopSoundByID(p.mo, sfx_BKSHA1)
		S_StopSoundByID(p.mo, sfx_BKSHA2)
		p.mo.SaySpearRightNow = false
	end
	//chaos (spear) voice line
	if p.mo.SayChaosRightNow2
		if not S_SoundPlaying(p.mo, sfx_bkchas)
			S_StartSound(p.mo, sfx_bkchas)
		end
		S_StopSoundByID(p.mo, sfx_BKSHA1)
		S_StopSoundByID(p.mo, sfx_BKSHA2)
		p.mo.SayChaosRightNow2 = false
	end

	
	--print(p.mo.colormap)
	if p.mo.state == S_KART_DEAD
			if p.mo.state != p.mo.shadowlaststate
				S_StartSound(p.mo, sfx_csnap)
			end
			p.mo.tics = min($, 1)
			if (p.mo.frame & FF_FRAMEMASK) == 10
				p.mo.renderflags = $|RF_DONTDRAW
			end
	end
	if p.invincibilitytimer > 0
		if not (p.mo.chaoscontrol_emerald and p.mo.chaoscontrol_emerald.valid)
			local em = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SHADOW_CHAOSCONTROL)
			em.scale = p.mo.scale/10
			em.target = p.mo
			--em.state = S_SHADOW_CHAOSEMERALD
			em.color = SKINCOLOR_LIME
			em.emerald = true
			p.mo.chaoscontrol_emerald = em 
			
		end
		if S_SoundPlaying(p.mo, sfx_BKSHGL)
			S_StopSoundByID(p.mo, sfx_BKSHGL)
			S_StartSoundAtVolume(p.mo, sfx_ccont, 255)
		end
	end
	p.mo.shadowlaststate = p.mo.state
end)
addHook("MobjThinker", function(mo)
	if mo.valid and mo.target.valid
		mo.lifetime = $ or 25
		mo.lifetime = $+1
		P_MoveOrigin(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.angle+FixedAngle((mo.lifetime*3 % 360)*FRACUNIT), 65*mo.target.scale) , mo.target.y+P_ReturnThrustY(mo, mo.target.angle+FixedAngle((mo.lifetime*3 % 360)*FRACUNIT), 65*mo.target.scale) , mo.target.z+50*mo.target.scale)
		if not mo.underlay and mo.emerald --spawn corona
			local ul = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SHADOW_CHAOSCONTROL)
			ul.state = S_SHADOW_CHAOSCONTROL_ORB
			ul.color = mo.color
			ul.renderflags = $|RF_ADD|RF_TRANS50
			ul.target = mo.target
			ul.dispoffset = -4
			ul.isunderlay = true
			ul.scale = mo.scale
			mo.underlay = ul
			--print("test")
		end
		if mo.isunderlay
			mo.spritexscale = FRACUNIT+cos(ANG10*mo.lifetime)/4
			mo.spriteyscale = FRACUNIT+cos(ANG10*mo.lifetime)/4
			mo.rollangle = FixedAngle((LRNG.NextRange(mo.target.ShadowRNGSeed, 0, 360))*FRACUNIT)
		end
		if mo.emerald and leveltime % 4 == 2 -- spawn chaos control beams
			local beam = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SHADOW_CHAOSCONTROL)
			beam.target = mo.target
			if LRNG.NextRange(mo.target.ShadowRNGSeed, 1, 2) == 1
				beam.dir = 1
			else
				beam.dir = -1
			end
			beam.lifetime = mo.lifetime
			beam.spritexscale = FRACUNIT+FRACUNIT/2
			beam.spriteyscale = beam.spritexscale
			beam.color = mo.color
			beam.rollangle = FixedAngle((LRNG.NextRange(mo.target.ShadowRNGSeed, 0, 360))*FRACUNIT)
			beam.fuse = 25
			beam.dispoffset = -2
			beam.IsBeam = true
			beam.state = S_SHADOW_CHAOSCONTROL_BEAM
			beam.renderflags = $|RF_ADD|RF_TRANS70
		end
		if mo.IsBeam
			mo.rollangle = $+FixedAngle(4*FRACUNIT)*mo.dir
			mo.spritexscale = $-FRACUNIT/13
			mo.spriteyscale = mo.spritexscale
		end
		mo.spriteyoffset = 10*cos(ANG10*mo.lifetime) --float up & down
		if mo.target.player.invincibilitytimer == 0
			mo.disappear = $ or 1
		end
		if not mo.disappear
			mo.scale = min(mo.target.scale, mo.scale+mo.target.scale/18)
		else
			mo.disappear = $+1
			mo.scale = $-mo.target.scale/7
			if mo.disappear == 7
				P_RemoveMobj(mo)
			end
		end
	end
end, MT_SHADOW_CHAOSCONTROL)
addHook("MobjThinker", function(mo)
	if mo.target and mo.target.skin == "bikeshadow"
		if mo.target.player.invincibilitytimer > 0
			mo.color = SKINCOLOR_SAPPHIRE
		end
	end
end, MT_GHOST)
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.target and mo.target.skin == "bikeshadow"
		P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	end
end, MT_CHAOSBLAST)
addHook("MobjThinker", function(mo)
	if not (mo and mo.target and mo.target.valid and mo.target.skin == "bikeshadow") return end
	if mo.state == S_KART_LEFTOVER_NOTIRES
		mo.state = S_DARKRIDER_BORKED
	end
end, MT_KART_LEFTOVER)